C         *******************************************************
C           FOR SUN WORKSTATION
C           MAIN PROGRAM(4 layers)
C           you can use supervized or unsupervized lerning ;
C                   control gain ;
C                   display A ;
C           ratio between X and Y can be arbitrary
C           (FBNDK.F & FBNPR.F are integrated into FBNDP.F)
C           27-MAR-90
C           new gain control system is used 04-JUL-90(g1,g2)
C           last edit Feb, 1991
C         *******************************************************
C
C       FBNEO2       MAIN PROGRAM
C       last edition 15-Feb-1991
 
        PARAMETER  (LH=4)
        PARAMETER  (      NSX1=28, NSX2=28, NSX3=16,  NSX4= 10)
        PARAMETER  (      NSY1=9,  NSY2=9 , NSY3= 5,  NSY4= 3)
        PARAMETER  (NCX0=28,  NCX1=28,  NCX2=16,  NCX3=16, NCX4=0)
        PARAMETER  (NCY0= 9,  NCY1= 9,  NCY2= 5,  NCY3= 5, NCY4=0)
        PARAMETER  (       NT1=1,   NT2=2,   NT3=1  ,NT4=1)
        PARAMETER  (       NA1=1,   NA2=2,   NA3=2  ,NA4=3)
        PARAMETER  (       ND1=1,   ND2=2,   ND3=1  ,ND4=3)
        PARAMETER  (KK0=1, KK1= 8,  KK2=32,  KK3=40 ,KK4=5)
        PARAMETER  (       NEL1=1,  NEL2=4,  NEL3=4 ,NEL4=6)
C    -- for calculation of response only --
        PARAMETER  (       NDD1=3,  NDD2=5,  NDD3=3)
C    -- for lerning only --
        PARAMETER  (       NAI1=1,  NAI2=2,  NAI3=2,  NAI4=3)
        PARAMETER  (       NDL1=1,  NDL2=1,  NDL3=1,  NDL4=6)
        PARAMETER  (       NDL01=4, NDL02=4, NDL03=2, NDL04=6)
        PARAMETER  (       IAL1=12, IAL2=300,IAL3=400,IAL4=320)
C   --  maximum number of patterns to store --
        PARAMETER  (NSTRINGS=10)
 
        INTEGER  NSX(  LH)  /      NSX1, NSX2, NSX3, NSX4/
        INTEGER  NSY(  LH)  /      NSY1, NSY2, NSY3, NSY4/
        INTEGER  NCX(0:LH)  /NCX0, NCX1, NCX2, NCX3, NCX4/
        INTEGER  NCY(0:LH)  /NCY0, NCY1, NCY2, NCY3, NCY4/
        INTEGER  NT(  LH)   /      NT1,  NT2,  NT3,  NT4/
        INTEGER  NA(  LH)   /      NA1,  NA2,  NA3,  NA4/
        INTEGER  ND(  LH)   /      ND1,  ND2,  ND3,  ND4/
        INTEGER  KK(0:LH)   /KK0,  KK1,  KK2,  KK3,  KK4/
        INTEGER  IALIM( LH) /      IAL1, IAL2, IAL3, IAL4/
        INTEGER  NELAT(LH)  /      NEL1, NEL2, NEL3, NEL4/
C    -- for calculation of response only --
        INTEGER  NDD( LH-1) /      NDD1, NDD2 ,NDD3  /
C    -- for lerning only --
        INTEGER  NAINI(LH)  /      NAI1, NAI2, NAI3, NAI4/
        INTEGER  NDLAT(LH)  /      NDL1, NDL2, NDL3, NDL4/
        INTEGER  NDLAT0(LH) /      NDL01,NDL02,NDL03,NDL04/
 
        INTEGER  IA(KK0*KK1  +KK1*KK2   +KK2*KK3   +KK3*KK4)
        REAL  US((NSX1*2+1)*(NSY1*2+1)*KK1
     &          +(NSX2*2+1)*(NSY2*2+1)*KK2
     &          +(NSX3*2+1)*(NSY3*2+1)*KK3
     &          +(NSX4*2+1)*(NSY4*2+1)*KK4)
        REAL  USM(KK1        +KK2       +KK3       +KK4 )
        REAL  WS((NSX1*2+1)*(NSY1*2+1)*KK1
     &          +(NSX2*2+1)*(NSY2*2+1)*KK2
     &          +(NSX3*2+1)*(NSY3*2+1)*KK3
     &          +(NSX4*2+1)*(NSY4*2+1)*KK4)
        REAL  WSM(KK1        +KK2       +KK3       +KK4 )
        REAL  XS((NSX1*2+1)*(NSY1*2+1)*KK1
     &          +(NSX2*2+1)*(NSY2*2+1)*KK2
     &          +(NSX3*2+1)*(NSY3*2+1)*KK3
     &          +(NSX4*2+1)*(NSY4*2+1)*KK4)
        REAL  B (KK1         +KK2       +KK3       +KK4 )
        REAL  C ((NA1*2+1)**2+(NA2*2+1)**2+(NA3*2+1)**2+(NA4*2+1)**2)
        REAL  D ((ND1*2+1)**2+(ND2*2+1)**2+(ND3*2+1)**2+(ND4*2+1)**2)
        REAL  A ((NA1*2+1)**2*IAL1+(NA2*2+1)**2*IAL2
     &          +(NA3*2+1)**2*IAL3+(NA4*2+1)**2*IAL4)
        REAL  AINI((NAI1*2+1)**2+(NAI2*2+1)**2
     &            +(NAI3*2+1)**2+(NAI4*2+1)**2)
        REAL  ELAT((NEL1*2+1)**2*2+(NEL2*2+1)**2*2
     &            +(NEL3*2+1)**2*2+(NEL4*2+1)**2*2)
        REAL  DLAT((NDL1*2+1)**2+(NDL2*2+1)**2
     &            +(NDL3*2+1)**2+(NDL4*2+1)**2)
        REAL  DLAT0((NDL01*2+1)**2+(NDL02*2+1)**2
     &             +(NDL03*2+1)**2+(NDL04*2+1)**2)
 
        REAL  DD((NDD1*2+1)**2    +(NDD2*2+1)**2    +(NDD3*2+1)**2)
 
        REAL  UC((NCX0*2+1)*(NCY0*2+1)*KK0+(NCX1*2+1)*(NCY1*2+1)*KK1
     &          +(NCX2*2+1)*(NCY2*2+1)*KK2+(NCX3*2+1)*(NCY3*2+1)*KK3
     &          +(NCX4*2+1)*(NCY4*2+1)*KK4)
        REAL  UCM( KK0     +KK1     +KK2     +KK3    +KK4)
        REAL  WC((NCX0*2+1)*(NCY0*2+1)*KK0+(NCX1*2+1)*(NCY1*2+1)*KK1
     &          +(NCX2*2+1)*(NCY2*2+1)*KK2+(NCX3*2+1)*(NCY3*2+1)*KK3
     &          +(NCX4*2+1)*(NCY4*2+1)*KK4)
        REAL  WCM( KK0     +KK1     +KK2     +KK3    +KK4)
        REAL  G1((NCX0*2+1)*(NCY0*2+1)*KK0+(NCX1*2+1)*(NCY1*2+1)*KK1
     &          +(NCX2*2+1)*(NCY2*2+1)*KK2+(NCX3*2+1)*(NCY3*2+1)*KK3)
        REAL  G2((NCX0*2+1)*(NCY0*2+1)*KK0+(NCX1*2+1)*(NCY1*2+1)*KK1
     &          +(NCX2*2+1)*(NCY2*2+1)*KK2+(NCX3*2+1)*(NCY3*2+1)*KK3)
C       ******WCX(L=0):dummy
        REAL  WCX((NCX0*2+1)*(NCY0*2+1)*KK0+(NCX1*2+1)*(NCY1*2+1)*KK1
     &           +(NCX2*2+1)*(NCY2*2+1)*KK2+(NCX3*2+1)*(NCY3*2+1)*KK3
     &           +(NCX4*2+1)*(NCY4*2+1)*KK4)
        REAL  WCXM(KK0     +KK1     +KK2     +KK3   +KK4)
 
        REAL  P((NCX0*2+1)*(NCY0*2+1))
        REAL  XX(LH)
 
        INTEGER  JUS(LH), JUC(0:LH), JK(LH), JK0(0:LH)
        INTEGER  JA(LH), JIA(LH), JC(LH), JD(LH), JDD(LH-1)
        INTEGER  JAINI(LH), JELAT(LH), JDLAT(LH), JDLAT0(LH)
 
C       ***   parameters   ***
C       **********RESUS   , RESUS   , RESUC    , Coefec.C
C                 Coefec.D    , Coefec.ELAT1, Coefec.ELAT1
C                 Coefec.ELAT2, Coefec.ELAT1, Coefec.ELAT2
        REAL  RT(LH)      /2.1,  4.1,   1.5,   1.5/
        REAL  SIG(LH)     / 50,   10,   1.0,   1.0/
        REAL  ALPHD(LH)   /4.0,  4.0,   4.0,   2.5/
        REAL  CPARA(LH)   /0.9,  0.9,   0.9,   0.9/
        REAL  DPARA(LH)   /0.9,  0.9,   0.8,   1.0/
        REAL  ELPARA0(LH) /0.3,  0.3,   0.1,   0.1/
        REAL  ELPARA1(LH) /0.7,  0.7,   0.9,   1.0/
        REAL  ELPARA2(LH) /0.05, 0.05,  0.6,   1.0/
        REAL  ELMAG1(LH)  /0.001, 0.15,  0.12,  0.15/
        REAL  ELMAG2(LH)  /0.001,  100.0,   0.25,  0.05/
 
C       ***  parameters for calculation response only ***
C       **********Sub.GAIN , Sub.GAIN , Sub.GAINHA, Sub.RESWC
C                 Sub.RESWS, Sub.RESXS, Sub.RESXS , Sub.RESXX
C                 Sub.RESXX, Sub.RESXX, Coefc.DD  , Coefec.DD
C             GAM0 for G1 integration, GAM1 for G2 integration
C             GAM2 for G1 recovery   , GAM3 for G2 recovery 
C             AMP  for G1's amplitude
        REAL  GAM0(0:LH)  / 0.1,  0.1,  0.1,   0.1,   0.1/
        REAL  GAM1(0:LH)  / 0.1,  0.1,  0.1,   0.1,   0.1/
        REAL  GAM2(0:LH)  /0.001,0.001,0.01, 0.01 , 0.5/
        REAL  GAM3(0:LH)  /0.9999,0.9999,0.999, 0.99 , 0.5/
        REAL  AMP(0:LH)   / 5.0, 5.0, 5.0, 5.0, 5.0/
        REAL  ALPH(0:LH-1)/ 18,   15, 15.0,   9.0       /
        REAL  ALPHWS(LH)  /      1.0,  1.0,   1.0,  10.0/
        REAL  BETA0(LH-1) /      1.0,  1.0,   1.0       /
        REAL  BETA1(LH-1) /      0.5,  0.5,   1.0       /
        REAL  BETX0(LH)   /      0.125,0.125, 0.25,  0.5/
        REAL  BETX1(LH)   /      0.8,  0.8,   0.8,   0.8/
        REAL  DDPARA(LH-1)/      0.95, 0.95,  0.9       /
        REAL  DDMAG(LH-1) /      20.0, 20.0,  20.0       /
 
C    -- SDV() for attention, SDV2 for decision of fixpoint --
C       **********Coefec.AINI , Coefec.AINI, Coefec.DLAT
C                 Coefec.DLAT0, Sub.ORG  ********
        REAL  AIPARA(LH)  /0.7,  0.7,   0.6,   0.91/
        REAL  AIMAG(LH)   /0.02, 0.02,  0.0002,0.00002/
        REAL  DLPARA(LH)  /0.8,  0.8,   0.8,   1.0/
        REAL  DLPARA0(LH) /0.8,  0.8,   0.7,   1.0/
        REAL  Q(LH)       /5.0,  5.0,   1.0,   1.0/
 
        CHARACTER  CHAR*6
        INTEGER  IW/6/
 
C       ***  Additions ***
        INTEGER  IAMAX(LH),LLL,IWC(0:LH),PAT,COEFF
        INTEGER  NUM,DISP,TEACHER
 
C       ***  additions for gain control ***
C            WHATISAW; this stores recognized patterns code 
C                      and X-Ycoordinates of them
C            STRPOINT; pointer which indicates 
C                      how many patterns are already stored
C            ATT; layer in which the fixpoint is decided
C            LIMIT; minimum response at which recognition system stops
        INTEGER STDDV(0:LH-1)  /10, 8, 7, 5/
        INTEGER WHATISAW(3,NSTRINGS),STRPOINT,ATT/1/,OUTPUTS,GRAPH
C       INTEGER DUM for picture
        REAL  FIXX,UCMAX,LIMIT/00.0/,SUMC(0:LH-1),OLDSUMC,STEAD/0.30/
	REAL  SUMMAX,THRETH/1.20/
 
C******* MAIN ROUTINE *****************************************
 
C       ***  setting for output ***
 1      IWC(0) =   1*16+  1
        IWC(1) =   0*16+  0
        IWC(2) =   0*16+  0
        IWC(3) =   0*16+  0
        IWC(4) =   1*16+  0
 
C       ***  Set Address  ***
        CALL SETADR(JUS, JUC, JK, JK0, JA, JIA, JC, JD, JDD,
     &              JAINI, JELAT, JDLAT, JDLAT0, LH, NSX, NSY,
     &              NCX, NCY, NA, ND, KK, IALIM, NDD, NAINI,
     &              NELAT, NDLAT, NDLAT0)
 
C       ***  selention of mode ***
 10     CALL MODE(LTRAIN, LH)
        IF(LTRAIN .EQ. -1) THEN
          LTRAIN=0
          GRAPH=0
        ELSE
          GRAPH=1
        END IF

        IWDK=0
        IF (LTRAIN .GT. 0)  THEN
          LEND=LTRAIN-1
        ELSE
          LEND=LH
        END IF
 
C       ***  loading of coeff. ***
        WRITE(*,*) 'Input Coeff-file number to read.'
        READ (*,*) COEFF
        DO 2000 L=1,LEND
          LLL=L
          CALL RWDISK(COEFF,A(JA(L)), IA(JIA(L)), B(JK(L)), IAMAX(L),
     &              KK(L-1), KK(L), NA(L), LLL, 1)
 2000   CONTINUE
        DO 2001 L=LEND+1,LH
          IAMAX(L)=0
 2001   CONTINUE
        DO 2012 L=1,LH
            WRITE (*,1000) L,IAMAX(L)
 1000       FORMAT (/'IAMAX(',I1,')=',I4)
 2012   CONTINUE
        IF ((LTRAIN.GE.2) .AND. (IAMAX(LEND).LE.0))  THEN
        GO TO 10
C                                ! Read LTRAIN again
        END IF
 
C       ***  setting and initializing of coeff. ***
        DO 2002 L=1,LH
          CALL COEFC(C(JC(L)), NA(L), CPARA(L), 100.0)
          CALL COEFC(D(JD(L)), ND(L), DPARA(L), 1.0)
          CALL COEFEL(ELAT(JELAT(L)), NELAT(L), ELPARA0(L),
     &                ELPARA1(L), ELPARA2(L), ELMAG1(L), ELMAG2(L))
 2002   CONTINUE
        IF (LTRAIN .EQ. 0)  THEN
          DO 2003 L=1,LH-1
            CALL COEFC(DD(JDD(L)), NDD(L), DDPARA(L), DDMAG(L))
 2003     CONTINUE
        ELSE
          L=LTRAIN
          CALL COEFC(AINI(JAINI(L)), NAINI(L), AIPARA(L), AIMAG(L))
          CALL COEFC(DLAT(JDLAT(L)), NDLAT(L), DLPARA(L), 100.0)
          CALL COEFC(DLAT0(JDLAT0(L)), NDLAT0(L), DLPARA0(L),100.0)
          DO 2004 K = 0, KK(L)-1
            B(JK(L)+K)=0.0
 2004     CONTINUE
          DO 2005 I = 0, KK(L-1)*KK(L)-1
            IA(JIA(L)+I)=0
 2005     CONTINUE
          INITIAL=1
C                   ! Used as a flag for initial entry
          KLAST=0
        END IF
 
C       ***  selection of pattern, input IW & IWC
        WRITE (*,*) 'Input pattern-file number.'
        READ (*,*) PAT
        IF (LTRAIN .NE. 0) THEN
          WRITE(*,*) 'Learning with teacher? (Y-1, N-0)'
          READ(*,*) TEACHER
          WRITE(*,*) 'Display coeff. A & B ? (1-A, 2-B, 3-AB, 0-No)'
          READ(*,*) DISP
        END IF
        KLAST1=1

        IF(GRAPH .EQ. 1) THEN
	   CALL MAKEWINDOW()
	   CALL INITW()
        END IF

 100    CALL CONTRL(LTRAIN,PAT,P,NCX(0),NCY(0),KK(LTRAIN)
     &             ,KTR,MTR,NTR,IW,IWC,*900)
 
        IF(GRAPH .EQ. 1) THEN
	  CALL CLSW()
	  CALL SCALE(1070,090)
	  CALL MESS('Start recognition')
        END IF
C       ***  initialization of parameters ***
        IF ((LTRAIN.EQ.0) .OR. (INITIAL.GT.0))  THEN
          ITMAX=0
C                         ! Initial set of repetition cycles (Default)
          CHAR='      '
C                         ! To be printed with IT
          IT=0
          DO 2006 L=0,LH-1
            CALL INIT(G1(JUC(L)),NCX(L),NCY(L),KK(L),0.0)
            CALL INIT(G2(JUC(L)),NCX(L),NCY(L),KK(L),0.0)
 2006     CONTINUE
          DO 2007 L=1,LH
            XX(L)=0.0
            CALL INIT(XS(JUS(L)),NSX(L),NSY(L),KK(L),0.0)
 2007     CONTINUE
          CALL INIT(WC(JUC(0)),NCX(0),NCY(0),KK(0),0.0)
          WCM(JK0(0))=0.0
          INITIAL=0
C                 INIT    ! Effective in training only
        END IF
        STRPOINT=0
 
C       ***  shift of pattern ***
        IF (LTRAIN .GT. 0)  THEN
          CALL SHIFT(P, NCX(0), NCY(0), IT/5, LTRAIN)
C                                            !!! 5 is No. of category
        END IF
 
C       ***  calculation of forward response to decide fixpoint ***
 150    IF (IT .GE. 40) THEN
           WRITE(*,*) 'Out of recongition time!'
           IF(GRAPH .EQ. 1) THEN
             CALL MESS('Out of recognition time.')
           END IF
           GOTO 100
        END IF
        CALL RESU0(UC(JUC(0)),WC(JUC(0)),P,NCX(0), NCY(0))
        CALL GAINP(UC(JUC(0)), G1(JUC(0)), G2(JUC(0)), AMP(0),
     &             NCX(0), NCY(0),KK(0))
        CALL U0MAX(UC(JUC(0)),UCM(JK0(0)),NCX(0), NCY(0),KK(0))
C       IF (AND(IWC(0), 2**4) .NE. 0)  THEN
C         CALL PRINT(UC(JUC(0)), NCX(0), NCY(0), KK(0), 1 , 0, IW)
C       END IF
 
        DO 3001 L=1,ATT
          LLL=L
          CALL RESUS(US(JUS(L)), USM(JK(L)), UC(JUC(L-1)),
     &               UCM(JK0(L-1)), XS(JUS(L)), XX(L), A(JA(L)),
     &               IA(JIA(L)), B(JK(L)), C(JC(L)), RT(L), SIG(L),
     &               NSX(L), NSY(L), KK(L), NCX(L-1), NCY(L-1),
     &               KK(L-1), NA(L))
          CALL LATUS(US(JUS(L)), USM(JK(L)), ELAT(JELAT(L)), 
     &               NSX(L), NSY(L), KK(L), NELAT(L))
C         IF (AND(IWC(L),2**5) .NE. 0)  THEN
C           CALL PRINT(US(JUS(L)), NSX(L), NSY(L), KK(L), 3 , LLL, IW)
C         END IF
 
          CALL RESUC(UC(JUC(L)),UCM(JK0(L)), US(JUS(L)),
     &               USM(JK(L)),D(JD(L)), ALPHD(L),
     &               NCX(L), NCY(L), KK(L), NSX(L), NSY(L),
     &               NT(L), ND(L))
          CALL GAINP(UC(JUC(L)),G1(JUC(L)), G2((JUC(L))), AMP(L),
     &               NCX(L),NCY(L),KK(L))
C         IF (AND(IWC(L),2**4) .NE. 0)  THE)
C           CALL PRINT(UC(JUC(L)), NCX(L), NCY(L), KK(L),2, LLL, IW)
C         END IF
 3001   CONTINUE
 
        CALL ATTCTRL(UC(JUC(ATT)),WC(JUC(ATT)),NCX(ATT),NCY(ATT),
     &               KK(ATT),FIXX,LIMIT,SUMMAX)
	IF(SUMMAX .LT. THRETH) THEN
	  ITADD=0
          IF(GRAPH .EQ. 1) THEN
	    CALL MESS('End of recognition')
          END IF
	  GOTO 100 
	END IF
        WRITE(*,*) "  FIXX=",FIXX

        IF(GRAPH .EQ. 1) THEN
	  CALL MESS('Serch area is decided.')
        END IF
C       ***  one_cycle of calcualtion response ***
 200    CONTINUE
        WRITE (*,1001)  IT, CHAR
 1001   FORMAT ('IT=',I3,3X,A6,5X,30('#'))
        IF(GRAPH .EQ. 1) THEN
	  CALL TIME(IT)
	  CALL PRINTRECT(NCX(0), NCY(0), KK(0),40,90,  5)
	  CALL PRINTRECT(NCX(1), NCY(1), KK(1),367,90, 2)
	  CALL PRINTRECT(NCX(2), NCY(2), KK(2),528,90, 2)
	  CALL PRINTRECT(NCX(3), NCY(3), KK(3),775,90, 2)
	  CALL PRINTRECT(NCX(4), NCY(4), KK(4),1025,95,15)
	  CALL PRINTRECT(NCX(4), NCY(4), KK(4),1025,435,15)
	  CALL PRINTRECT(NCX(3), NCY(3), KK(3),775,430,2)
	  CALL PRINTRECT(NCX(2), NCY(2), KK(2),528,430,2)
	  CALL PRINTRECT(NCX(1), NCY(1), KK(1),367,430,2)
	  CALL PRINTRECT(NCX(0), NCY(0), KK(0),40,430, 5)
	  CALL STR('Uc0',04,110)
	  CALL STR('Uc1',333,110)
	  CALL STR('Uc2',491,110)
	  CALL STR('Uc3',741,110)
	  CALL STR('Uc4',0987,110)
	  CALL STR('Wc0',00,450)
	  CALL STR('Wc1',329,450)
	  CALL STR('Wc2',489,450)
	  CALL STR('Wc3',737,450)
	  CALL STR('Wc4',0985,450)
          CALL LETTER(1045,110,15)
          CALL LETTER(1045,450,15)
	  CALL MESS('Calculating forward resp.')
        END IF
 
C       ***  calculation of forward response ***
        CALL RESU0(UC(JUC(0)), WC(JUC(0)),P,NCX(0), NCY(0))
        CALL GAINP(UC(JUC(0)), G1(JUC(0)), G2(JUC(0)), AMP(0),
     &             NCX(0), NCY(0),KK(0))
        CALL GAINS(UC(JUC(0)),NCX(0),NCY(0),KK(0),UCM(JK0(0))
     &              ,STDDV(0),FIXX ,SUMC(0))
        IF (AND(IWC(0), 2**4) .NE. 0)  THEN
          CALL PRINT(UC(JUC(0)), NCX(0), NCY(0), KK(0), 1 , 0, IW)
        END IF
        IF(GRAPH .EQ. 1) THEN
          CALL PRINTD(UC(JUC(0)), NCX(0), NCY(0), KK(0),40,90,5)
        END IF
 
        DO 2008 L=1,LEND
          LLL=L
          CALL RESUS(US(JUS(L)), USM(JK(L)), UC(JUC(L-1)),
     &               UCM(JK0(L-1)), XS(JUS(L)), XX(L), A(JA(L)),
     &               IA(JIA(L)), B(JK(L)), C(JC(L)), RT(L), SIG(L),
     &               NSX(L), NSY(L), KK(L), NCX(L-1), NCY(L-1),
     &               KK(L-1), NA(L))
          CALL LATUS(US(JUS(L)), USM(JK(L)), ELAT(JELAT(L)), 
     &               NSX(L), NSY(L), KK(L), NELAT(L))
          IF (AND(IWC(L),2**5) .NE. 0)  THEN
            CALL PRINT(US(JUS(L)), NSX(L), NSY(L), KK(L), 3 , LLL, IW)
          END IF
 
          IF (L .LT. LH)  THEN
            CALL RESUC(UC(JUC(L)),UCM(JK0(L)), US(JUS(L)),
     &                 USM(JK(L)),D(JD(L)), ALPHD(L),
     &                 NCX(L), NCY(L), KK(L), NSX(L), NSY(L),
     &                 NT(L), ND(L))
            CALL GAINP(UC(JUC(L)),G1(JUC(L)),G2(JUC(L)), AMP(L),
     &                 NCX(L),NCY(L),KK(L))
            CALL GAINS(UC(JUC(L)),NCX(L), NCY(L), KK(L),UCM(JK0(L))
     &                ,STDDV(L), FIXX ,SUMC(L))
C         write(*,*) "L=",L,"  SUMC(L)=",SUMC(L)
 
            IF (AND(IWC(L),2**4) .NE. 0)  THEN
              CALL PRINT(UC(JUC(L)), NCX(L), NCY(L), KK(L),2, LLL, IW)
            END IF
            IF(GRAPH .EQ. 1) THEN
              IF (L .EQ. 1)  THEN
                CALL PRINTD(UC(JUC(L)), NCX(L), NCY(L), KK(L),367,90, 2)
              END IF
              IF (L .EQ. 2)  THEN
                CALL PRINTD(UC(JUC(L)), NCX(L), NCY(L), KK(L),528,90, 2)
              END IF
              IF (L .EQ. 3)  THEN
                CALL PRINTD(UC(JUC(L)), NCX(L), NCY(L), KK(L),775,90, 2)
              END IF
            END IF
          ELSE
            CALL RESUCH(UC(JUC(L)), UCMAXH, US(JUS(L)),
     &                 USM(JK(L)), ALPHD(L),
     &                 KK(L), NSX(L), NSY(L))
            IF (AND(IWC(L), 2**4) .NE. 0)  THEN
              CALL PRICLH(UC(JUC(L)), KK(L), 1    , LLL, IW)
            END IF
            IF(GRAPH .EQ. 1) THEN
              IF (L .EQ. 4)  THEN
                CALL PRINTD(UC(JUC(L)), NCX(L), NCY(L),KK(L),1025,95,15)
              END IF
            END IF
          END IF
 2008   CONTINUE
C       ***  end of forward response ***
 
 
C       *** leaning ***
        IF (LTRAIN .GT. 0)  THEN
          L=LTRAIN
          IF((TEACHER .EQ. 0).OR.(MTR .EQ. 99)) THEN
            CALL ORGNT(L,A(JA(L)), IA(JIA(L)), B(JK(L)),
     &             KLAST, IAMAX(L), IALIM(L),
     &             US(JUS(L)), USM(JK(L)), UC(JUC(L-1)), UCM(JK0(L-1)),
     &             XS(JUS(L)), C(JC(L)), AINI(JAINI(L)),
     &             DLAT(JDLAT(L)), DLAT0(JDLAT0(L)), RT(L), SIG(L),
     &             Q(L), NSX(L), NSY(L), KK(L), NCX(L-1), NCY(L-1),
     &             KK(L-1), NA(L), NAINI(L), NDLAT(L),NDLAT0(L),IW,DISP)
          ELSE
            IF(KLAST1 .LT. KTR) KLAST1=KTR
            CALL ORGT(L,KLAST1,KTR,MTR,NTR,A(JA(L)),IA(JIA(L)),B(JK(L)),
     &             IAMAX(L), IALIM(L),
     &             UC(JUC(L-1)), UCM(JK0(L-1)),
     &             C(JC(L)),
     &             Q(L), NSX(L), NSY(L), KK(L), NCX(L-1), NCY(L-1),
     &             KK(L-1), NA(L),DISP)
          END IF
          IF (AND(IWC(L),2**5) .NE. 0)  THEN
            CALL PRINT(US(JUS(L)), NSX(L), NSY(L), KK(L), 3  , L, IW)
          END IF
          IT=IT+1
          GO TO 100
C                                  ! Call CONTRL (Read next pat.)
        END IF
C       *************
 
C       ***  Response calculation only (Not used during training)  ***
        CALL RESXX(XX, UCMAXH, BETX0, BETX1, LH, IW)
C       ***  calculation of backward response ***
        IF (UCMAXH .GT. 0.0)  THEN
        IF(GRAPH .EQ. 1) THEN
          CALL MESS('Success in Recognition')
C          READ(*,*) DUM for picture
          CALL MESS('Calculating backward resp.')
        END IF
 2019     DO 2009 L=LH,0,-1
            LLL=L
            IF (L .EQ. LH)  THEN
              CALL RESWCH(WC(JUC(L)), WCM(JK0(L)), UC(JUC(L)),
     &                    UCMAXH, KK(L))
C             IF (AND(IWC(L),1) .NE. 0)  THEN
                CALL PRICLH(WC(JUC(L)), KK(L),  4   , LLL, IW)
C             END IF
              IF(GRAPH .EQ. 1) THEN
                CALL PRINTD(UC(JUC(L)),NCX(L),NCY(L),KK(L),1025,435,15)
              END IF
            ELSE
              CALL RESWC(WC(JUC(L)), WCM(JK0(L)), WS(JUS(L+1)),
     &               WSM(JK(L+1)), A(JA(L+1)), IA(JIA(L+1)), B(JK(L+1)),
     &               C(JC(L+1)),RT(L+1), ALPH(L), NCX(L), NCY(L),KK(L),
     &               NSX(L+1), NSY(L+1), KK(L+1), NA(L+1))
              IF (AND(IWC(L),1) .NE. 0)  THEN
                CALL PRINT(WC(JUC(L)), NCX(L), NCY(L), KK(L),4, LLL, IW)
              END IF
            IF(GRAPH .EQ. 1) THEN
            IF (L .EQ. 0)  THEN
              CALL PRINTD(WC(JUC(0)), NCX(0), NCY(0), KK(0),40,430,5)
            END IF
            IF (L .EQ. 1)  THEN
              CALL PRINTD(WC(JUC(L)), NCX(L), NCY(L), KK(L),367,430, 2)
            END IF
            IF (L .EQ. 2)  THEN
              CALL PRINTD(WC(JUC(L)), NCX(L), NCY(L), KK(L),528,430, 2)
            END IF
            IF (L .EQ. 3)  THEN
              CALL PRINTD(WC(JUC(L)), NCX(L), NCY(L), KK(L),775,430, 2)
            END IF
            END IF

            END IF
 
            IF (L .LT. LH)  THEN
              CALL GAIN(G1(JUC(L)),G2(JUC(L)),WC(JUC(L)),WCM(JK0(L)),
     &             GAM0(L),GAM1(L),GAM2(L),GAM3(L),NCX(L),NCY(L),KK(L))
              IF (AND(IWC(L),2**7) .NE. 0)  THEN
                CALL PRINT(G1(JUC(L)), NCX(L), NCY(L), KK(L), 6,LLL, IW)
              END IF
              IF (AND(IWC(L),2**6) .NE. 0)  THEN
                CALL PRINT(G2(JUC(L)), NCX(L), NCY(L), KK(L),12,LLL, IW)
              END IF
            END IF
 
            IF (L .GT. 0)  THEN
              IF(L .EQ. LH) THEN
                CALL RESWSH(WS(JUS(L)), WSM(JK(L)), WC(JUC(L)),
     &                     WCM(JK0(L)), US(JUS(L)), USM(JK(L)),
     &                     ALPHWS(L), NSX(L), NSY(L), KK(L),
     &                     NCX(L), NCY(L))
                IF (AND(IWC(L),2) .NE. 0)  THEN
                  CALL PRINT(WS(JUS(L)), NSX(L), NSY(L), KK(L),5,LLL,IW)
                END IF
              ELSE
                CALL RESWS(WS(JUS(L)), WSM(JK(L)), WC(JUC(L)),
     &                     WCM(JK0(L)), US(JUS(L)), USM(JK(L)),
     &                     D(JD(L)), ALPHWS(L), NSX(L), NSY(L), KK(L),
     &                     NCX(L), NCY(L), NT(L), ND(L))
                IF (AND(IWC(L),2) .NE. 0)  THEN
                  CALL PRINT(WS(JUS(L)), NSX(L), NSY(L), KK(L),5,LLL,IW)
                END IF
              END IF
              IF(L .LT. LH) THEN
                CALL RESWCX(WCX(JUC(L)), WCXM(JK0(L)), WC(JUC(L)),
     &            WCM(JK0(L)), US(JUS(L)), USM(JK(L)), DD(JDD(L)),
     &            NCX(L), NCY(L), KK(L), NSX(L), NSY(L), NT(L), NDD(L))
                IF (AND(IWC(L),4) .NE. 0)  THEN
                  CALL PRINT(WCX(JUC(L)),NCX(L),NCY(L),KK(L),7,LLL,IW)
                END IF
 
                CALL RESXS(XS(JUS(L)), WCX(JUC(L)), WCXM(JK0(L)),
     &                   D(JD(L)), BETA0(L), BETA1(L), NSX(L), NSY(L),
     &                   KK(L), NCX(L), NCY(L), NT(L), ND(L))
                IF (AND(IWC(L),8) .NE. 0)  THEN
                  CALL PRINT(XS(JUS(L)),NSX(L),NSY(L),KK(L),8,LLL,IW)
                END IF
              END IF
            END IF
 2009     CONTINUE

C  **** skip ,only after reset ****
        IF(ITADD .EQ. -1) THEN
           ITMAX=ITMAX+IABS(ITADD)
           ITADD=0
           GOTO 150
        END IF
C  *****************************************

          CHAR='      '
C                                ! To be printed with IT
        ELSE
C         ***  skip calculation of backward response ***
          ITMAX=ITMAX+1
	  CHAR='REPEAT' 
          IF(GRAPH .EQ. 1) THEN
            CALL MESS('Fail in recognition')
            CALL MESS('Trying again')
C            READ(*,*) DUM  for picture
          END IF
C                                ! To be printed with IT
        END IF
C       *** end of backward response ***
 
C       ***  Repetition control for response calculation only  ***
        IT=IT+1
        IF (IT .LE. ITMAX)  GO TO 200
   
C       ***  continue or not ***
C3000   WRITE (*,1002)
C1002   FORMAT('repeat<GE.1>,next pattern<0>,reset<-1>,quit<LT.-1>')
C       READ (*,1003)  ITADD
C1003   FORMAT (I5)
C       ************************

C       READ(*,*) DUM  for picture
C       *** Auto Switching ***
        OUTPUTS=0
        DO K=1,KK(LH)
           IF(UC(JUC(LH)+K-1) .GT. 0.0) OUTPUTS=OUTPUTS+1
        END DO 
        IF(OUTPUTS .EQ. 1) THEN
          IF(ABS(OLDSUMC-SUMC(3))/OLDSUMC .LT. STEAD) THEN
             ITADD=-1
             OLDSUMC=0.001
             IF(GRAPH .EQ. 1) THEN
               CALL MESS('Response becomes steady.')
             END IF
          ELSE
             ITADD=1
             IF(GRAPH .EQ. 1) THEN
               CALL MESS('Response is not steady.')
             END IF
          END IF
          OLDSUMC=SUMC(3)
        ELSE
          ITADD=1
          OLDSUMC=0.1
        END IF
        write(*,*) "OUTPUTS=",OUTPUTS," ITADD=",ITADD,
     &             " OLDSUMC=",OLDSUMC," SUMC(3)=",SUMC(3)
 
C       *** display the result of recognition ***
        DO 2018 N=1,STRPOINT
          WRITE(*,*) "CODE= ",WHATISAW(1,N)," :X= ",WHATISAW(2,N)
     &               ," :Y= ",WHATISAW(3,N)
 2018   CONTINUE
 
        IF (ITADD .EQ. 0)  GO TO 100
        IF (ITADD .LT. -1)  STOP
 
C       ***  on the case of reset ***
       IF (ITADD .EQ. -1)  THEN
          DO 2010 L=0,LH-1
            LLL=L
            IF (AND(IWC(L),2**7) .NE. 0)  THEN
              CALL PRINT(G1(JUC(L)), NCX(L), NCY(L), KK(L),9,LLL,IW)
            END IF
            IF (AND(IWC(L),2**6) .NE. 0)  THEN
              CALL PRINT(G2(JUC(L)), NCX(L), NCY(L), KK(L),12,LLL,IW)
            END IF

 2010     CONTINUE

          STRPOINT=STRPOINT+1
          UCMAX=0.0
          WHATISAW(1,STRPOINT)=-1
          DO 2017 K=1,KK(LH)
            IF (UC(JUC(LH)+K-1) .GT. UCMAX) THEN
               UCMAX=UC(JUC(LH)+K-1)
               WHATISAW(1,STRPOINT)=K
            END IF
 2017     CONTINUE
          WHATISAW(2,STRPOINT)=INT(FIXX*REAL(NCX(0)))
          WRITE(*,*) '***** FIXX=',FIXX
          WHATISAW(3,STRPOINT)=0
 
          DO 2011 L=1,LH
            XX(L)=0.0
            CALL INIT(XS(JUS(L)),NSX(L),NSY(L),KK(L),0.0)
 2011     CONTINUE
          CALL INIT(WC(JUC(0)),NCX(0),NCY(0),KK(0),0.0)
          WCM(JK0(0))=0.0
          CHAR='RESET'	  
          IF(GRAPH .EQ. 1) THEN
            CALL MESS('Switching attention')
C            READ(*,*) DUM  for picture
          END IF
          CALL INIT(UC(JUC(LH)),NCX(LH),NCY(LH),KK(LH),0.0)
          OLDSUMC=0.001
          GOTO 2019
       END IF
 
       ITMAX=ITMAX+IABS(ITADD)
       GO TO 200

c       ***  normalize and save coeff. ***
 900    IF (LTRAIN .GT. 0)  THEN
          L=LTRAIN
          CALL NORMALIZ(A(JA(L)), IA(JIA(L)), B(JK(L)),
     &                   KK(L-1), KK(L), NA(L))
          WRITE (*,*) 'Input Coeff-file number to write.'
          READ (*,*) NUM
          CALL RWDISK(NUM,A(JA(L)), IA(JIA(L)), B(JK(L)), IAMAX(L),
     &              KK(L-1), KK(L), NA(L), L, 0)
          DO 2014 L=1,LH
              WRITE (*,1000)  L,IAMAX(L)
 2014     CONTINUE
          IF (IW.GT.0 .AND. IW.NE.6) THEN
              DO 2015 L=1,LH
                  WRITE (IW,1000)  L,IAMAX(L)
 2015         CONTINUE
          END IF
          GOTO 1
       END IF
       STOP
       END
 
 
 
 
 
        SUBROUTINE SETADR(JUS,JUC,JK,JK0,JA,JIA,JC,JD,JDD,
     &                JAINI,JELAT,JDLAT,JDLAT0,
     &                LH,NSX,NSY,NCX,NCY,NA,ND,KK,IALIM,NDD,
     &                NAINI,NELAT,NDLAT,NDLAT0)
        INTEGER  JUS(LH), JUC(0:LH), JK(LH), JK0(0:LH)
        INTEGER  JA(LH), JIA(LH), JC(LH), JD(LH), JDD(LH-1)
        INTEGER  JAINI(LH), JELAT(LH), JDLAT(LH), JDLAT0(LH)
        INTEGER  NSX(LH), NSY(LH), NCX(0:LH), NCY(0:LH)
        INTEGER  NA(LH), ND(LH), KK(0:LH), IALIM(LH)
        INTEGER  NDD(LH-1), NAINI(LH), NELAT(LH)
        INTEGER  NDLAT(LH), NDLAT0(LH)
 
        JUC(0)=1
        JK0(0)=1
        DO 2000 L=0,LH-1
          JUC(L+1)=JUC(L) + (NCX(L)*2+1)*(NCY(L)*2+1)*KK(L)
          JK0(L+1) =JK0(L)  + KK(L)
 2000   CONTINUE
 
        JK(1)=1
        JUS(1)=1
        JA(1)=1
        JIA(1)=1
        JC(1)=1
        JD(1)=1
        JAINI(1)=1
        JELAT(1)=1
        JDLAT(1)=1
        JDLAT0(1)=1
        DO 2001 L=1,LH-1
          JK(L+1)    =JK(L)     + KK(L)
          JUS(L+1)   =JUS(L)    + (NSX(L)*2+1)*(NSY(L)*2+1)*KK(L)
          JA(L+1)    =JA(L)     + (NA(L)*2+1)**2*IALIM(L)
          JIA(L+1)   =JIA(L)    + KK(L-1)*KK(L)
          JC(L+1)    =JC(L)     + (NA(L)*2+1)**2
          JD(L+1)    =JD(L)     + (ND(L)*2+1)**2
          JAINI(L+1) =JAINI(L)  + (NAINI(L)*2+1)**2
          JELAT(L+1) =JELAT(L)  + (NELAT(L)*2+1)**2*2
          JDLAT(L+1) =JDLAT(L)  + (NDLAT(L)*2+1)**2
          JDLAT0(L+1)=JDLAT0(L) + (NDLAT0(L)*2+1)**2
 2001   CONTINUE
        JDD(1)=1
        DO 2002 L=1,LH-2
          JDD(L+1)=JDD(L) + (NDD(L)*2+1)**2
 2002   CONTINUE
        RETURN
        END
 
 
 
 
C       initilization of array
        SUBROUTINE INIT(U,MM,NN,KK,DATA)
        REAL  U(-MM:MM,-NN:NN,KK),DATA
        DO 2002 K=1,KK
          DO 2001 M=-MM,MM
            DO 2000 N=-NN,NN
              U(M,N,K)=DATA
 2000       CONTINUE
 2001     CONTINUE
 2002   CONTINUE
        RETURN
        END
 
 
 
 
 
 
        SUBROUTINE COEFEL(ELAT,NELAT,ELPARA0,ELPARA1,ELPARA2,
     &                    ELMAG1,ELMAG2)
        REAL  ELAT(-NELAT:NELAT,-NELAT:NELAT,2)
 
        CALL COEFC(ELAT(-NELAT,-NELAT,1), NELAT, ELPARA1, ELMAG1)
        CALL COEFC(ELAT(-NELAT,-NELAT,2), NELAT, ELPARA0, ELMAG1)
        DO 2001 N=-NELAT,NELAT
          DO 2000 M=-NELAT,NELAT
            ELAT(M,N,1)=ELAT(M,N,1)-ELAT(M,N,2)
 2000     CONTINUE
 2001   CONTINUE
C        write(*,*) 'pass0'
C        read(*,*) L
C        write(*,*) NELAT,ELPARA2,ELMAG2
        CALL COEFC(ELAT(-NELAT,-NELAT,2), NELAT, ELPARA2, ELMAG2)
C        write(*,*) 'pass1'
C        read(*,*) L
        RETURN
        END
 
 
 
 
 
C       *** If AMP=0.0, then nomalized to Sum C=1.0  ***
        SUBROUTINE COEFC(C,NN,R,AMP)
        REAL  C(-NN:NN,-NN:NN),S,CC,RN
 
        IF (AMP .GT. 99.0) THEN
          CAMP=1.0
        ELSE
          CAMP=AMP
        END IF
        S=0.0
C        write(*,*) R,CAMP,NN
C        read(*,*) L
        DO 2001 N=-NN,NN
          RN=R**REAL(N**2)*CAMP
          DO 2000 M=-NN,NN
            CC=RN*R**REAL(M**2)
            C(M,N)=CC
            S=S+CC
 2000     CONTINUE
 2001   CONTINUE
C        write(*,*) 'pass0-1'
C        read(*,*) L
        IF (AMP .GT. 99.0) THEN 
          DO 2003 N=-NN,NN
            DO 2002 M=-NN,NN
              C(M,N)=C(M,N)/S
 2002       CONTINUE
 2003     CONTINUE
        END IF
        RETURN
        END
 
 
 
 
 
C       selection of IW, IWC
        SUBROUTINE IWREAD(IW,IWC)
        PARAMETER  (LH=4)
        CHARACTER  L*1, LIN*1, IWCINP*10
        CHARACTER  HEX*16 /'0123456789ABCDEF'/
        INTEGER    IW,IWC(0:LH),IWCIN(0:LH),N,M,NN,MM
 
        IF (IW.EQ.1)  THEN
          L='W'
        ELSE IF (IW.EQ.2)  THEN
          L='P'
        ELSE
          L='T'
        END IF
 
 10     DO 1008 N=0,LH
          IWCIN(N)=IWC(N)
 1008   CONTINUE
 
        DO 1006 N=1,10
          NN=(N-1)/2
          MM=2+(NN*2)-N
          M=IWCIN(NN)/(16**MM)
          IWCINP(N:N)=HEX(M+1:M+1)
          IWCIN(NN)=IWCIN(NN)-M*(16**MM)
 1006   CONTINUE
 
        WRITE(*,*) ' input output_device and outputs( H to help)'
        WRITE (*,1002)  L, IWCINP
 1002   FORMAT (' old value: IW= ',A1,': IWC= ',A10)
        LIN=' '
        READ (*,1003,ERR=10) LIN,IWCINP
 1003   FORMAT(A1,A10)
 
        IF (LIN .EQ. 'S')  RETURN
        IF (LIN .EQ. 'W')  THEN
          IW=1
        ELSE IF (LIN .EQ. 'P')  THEN
          IW=2
        ELSE IF (LIN .EQ. 'T')  THEN
          IW=6
        ELSE IF (LIN .EQ. 'H')  THEN
          GOTO 1004
        ELSE
          GO TO 10
        END IF
 
        IF (IWCINP(1:1) .EQ. ' ')  RETURN
 
        DO 1010 N=0,LH
          IWCIN(N)=0
 1010   CONTINUE
 
        DO 1005 N=1,10
          NN=(N-1)/2
          MM=2+(NN*2)-N
          IWCIN(NN)=IWCIN(NN)+(INDEX(HEX,IWCINP(N:N))-1)*16**MM
 1005   CONTINUE
 
        DO 1009 N=0,LH
          IWC(N)=IWCIN(N)
 1009   CONTINUE
        RETURN
 
C       *** display help massage ***
 1004   WRITE (*,1001)
 1001   FORMAT (1X,'OUTPUT   T: Terminal,  P: Print,  W: Wide print'/
     &          1X,'Hexadec.*    *   |*    *   |*    *   |*    *   '/
     &          1X,'  1     UC0 WC0 UC1 WC1 UC2 WC2 UC3 WC3 UC4 WC4'/
     &          1X,'  2             US1 WS1 US2 WS2 US3 WS3 US4 WS4'/
     &          1X,'  4     G10     G11 WCX1G12 WCX2G13 WCX3       '/
     &          1X,'  8     G20     G21 XS1 G22 XS2 G23 XS3        ')
        GOTO 10
        END
 
 
 
 
 
C       simulation or learning ?
        SUBROUTINE MODE(LTRAIN,LH)
 
        INITTR=0
  110   WRITE (*,1001) LH
 1001   FORMAT(1X,' attention(no graphics) [-1 ] '/
     &         1X,' attention(use graphics)[ 0 ] '/
     &         1X,' learning               [ 1 - ',I2,' ]'/
     &         1X,' quit                   [ <= -1 ]')
        READ (*,1002)  LTRAIN
 1002   FORMAT (I2)
        IF (LTRAIN .LT. -1)   STOP
        IF (LTRAIN .LE. LH)  RETURN
         GOTO 110
        END

