
C       FBNTR0.FOR
C         ***  MODEL FOR SELECTIVE ATTENTION  ***
C           SUPERVISED LEARNING
C         **************************************************
C           FOR SUN WORKSTATION
C           can be supervized learning; can display coef.A
C           27-MAR-90
C         **************************************************
 
C    -- unsupervized learning --
        SUBROUTINE ORGNT(LTRAIN,A,IA,B,KLAST,IAMAX,IALIM,
     &             US,USM,UC,UCM,XS,C,AINI,DLAT,DLAT0,RT,SIG,Q,
     &             NSX,NSY,KS,NCX,NCY,KC,NA,NAINI,NDLAT,NDLAT0,IW,DISP)
        PARAMETER  (NSXM=28, NSYM=9, KSMAX=40)
        REAL  US(-NSX:NSX,-NSY:NSY,KS), USM(KS)
        REAL  UC(-NCX:NCX,-NCY:NCY,KC), UCM(KC)
        REAL  XS(-NSX:NSX,-NSY:NSY,KS)
        REAL  A(-NA:NA,-NA:NA,*), B(KS), C(-NA:NA,-NA:NA)
        INTEGER  IA(KC,KS),DISP,LTRAIN
        REAL  AINI(-NAINI:NAINI,-NAINI:NAINI)
        REAL  DLAT(-NDLAT:NDLAT,-NDLAT:NDLAT)
        REAL  DLAT0(-NDLAT0:NDLAT0,-NDLAT0:NDLAT0)
 
        REAL  USI(-NSXM:NSXM,-NSYM:NSYM)
        INTEGER  MTR(KSMAX), NTR(KSMAX)
        INTEGER  KTRR
 
 
C       CHARACTER FMT1*13 /'(1H0,6X,  I3)'/
C       CHARACTER FMT2*13 /'(1H0,6X,  I3)'/
C       CHARACTER FMT3*13 /'(1H0,6X,  I3)'/
CCC1001 FORMAT (1H0,5X,<KP>I3/ 1X,'MTR  ',<KP>I3/ 1X,'NTR  ',<KP>I3)
 
 
        IF (NSX .GT. NSXM)  STOP 'Too small buf. USI in sub. ORG(NSX)'
        IF (NSY .GT. NSYM)  STOP 'Too small buf. USI in sub. ORG(NSY)'
        IF (KS .GT. KSMAX)  STOP 'Too small buf. MTR, NTR in sub. ORG'
 
        IAMAX0=IAMAX
        DO 2000 K=1,KS
          MTR(K)=99
          NTR(K)=99
 2000   CONTINUE
 
        IF (KLAST .GT. 0)  THEN
          CALL RESUS(US, USM, UC, UCM, XS, 0.0, A, IA, B, C, RT, SIG,
     &               NSX, NSY, KLAST, NCX, NCY, KC, NA)
          CALL REP(MTR, NTR, US, NSX, NSY, KLAST)
          DO 2001 KTR=1,KLAST
            KTRR=KTR
            IF (MTR(KTR) .NE. 99)  THEN
              CALL DELTA(A, IA, B, C, UC, UCM, KTRR, MTR(KTR),
     &              NTR(KTR), IAMAX, IALIM, Q, NCX, NCY, KC, KS, NA)
            END IF
 2001     CONTINUE
        END IF
 
        IF (KLAST .GE. KS)  GO TO 500
C                                          ! PRINT AND STOP
 
 
        CALL RESUS(US, USM, UC, UCM, XS, 0.0, A, IA, B, C, RT, SIG,
     &             NSX, NSY, KS, NCX, NCY, KC, NA)
        CALL USINI(USI, UC, UCM, AINI, NSX, NSY, NCX, NCY, KC, NAINI)
        CALL LAT(USI, USIM, USI, DLAT0, NSX, NSY, NDLAT0)
        DO 2002 K=1,KLAST
          CALL LAT(USI, USIM, US(-NSX,-NSY,K), DLAT, NSX, NSY, NDLAT)
 2002   CONTINUE
 
        KTR1=KLAST+1
        KTR2=MIN(KTR1+7, KS)
C                                 ! AT MOST, 8 MORE PLANES
        DO 2003 KTR=KTR1,KTR2
          KTRR=KTR
          CALL REPINI(MTRK, NTRK, USI, NSX, NSY, *500)
C                                                 ! 500=interrupt do loop
          CALL DELTA(A, IA, B, C, UC, UCM, KTRR, MTRK, NTRK,
     &               IAMAX, IALIM, Q, NCX, NCY, KC, KS, NA)
          MTR(KTR)=MTRK
          NTR(KTR)=NTRK
          KLAST=KTR
          CALL RESUS(US(-NSX,-NSY,KTR), USM(KTR), UC, UCM, XS, 0.0,
     &               A, IA(1,KTR), B(KTR), C, RT, SIG,
     &               NSX, NSY, 1, NCX, NCY, KC, NA)
          IF (KTR .NE. KS)  THEN
            CALL LAT(USI,USIM,US(-NSX,-NSY,KTR),DLAT,NSX,NSY,NDLAT)
          END IF
 2003   CONTINUE
 
 
 500    IF (IW .GT. 0)  THEN
          DO 2004 KP1=1,KS,20
            KP2=MIN0(KS, KP1+19)
            KP=KP2-KP1+1
            WRITE (IW,1001) (K,K=KP1,KP2),(MTR(K),K=KP1,KP2),
     &                      (NTR(K),K=KP1,KP2)
 1001       FORMAT(5X,<KP>I3/1X,'MTR  ',<KP>I3/ 1X,'NTR  ',<KP>I3)
C           ENCODE(FMT1(9:10),'(I2)') KP
C           ENCODE(FMT2(9:10),'(I2)') KP
C           ENCODE(FMT3(9:10),'(I2)') KP
C           WRITE (IW,FMT1) (K, K=KP1,KP2)
C           WRITE (IW,FMT2) (MTR(K), K=KP1,KP2)
C           WRITE (IW,4000) 'MTR'
C4000       FORMAT (1H+,A3)
C           WRITE (IW,FMT3) (NTR(K), K=KP1,KP2)
C           WRITE (IW,4000) 'NTR'
 2004     CONTINUE
          WRITE (IW,1002)  IAMAX, IAMAX0
 1002     FORMAT (10X,'IAMAX=',I4,'  <--',I4)
        END IF
 
C       --- DISPLAY coeff. A ---
        IF ((DISP .EQ. 1).OR.(DISP .EQ. 3)) THEN
          DO 2005 K1=1,KLAST
              WRITE(*,*) 'KC(',KC,') ---> KS(',K1,')'
              CALL PRINT(A(-NA,-NA,IA(1,K1)),NA,NA,KC,10,LTRAIN,6)
 2005     CONTINUE
        END IF
 
C       --- DISPLAY coeff. B ---
        IF ((DISP .EQ. 2).OR.(DISP .EQ. 3)) THEN
          DO 2006 K1=1,KLAST
            WRITE(*,*) 'B(',K1,')=',B(K1)
 2006     CONTINUE
        END IF
 
        RETURN
        END
 
 
C     - supervized learning --
        SUBROUTINE ORGT(LTRAIN,KLAST,KTRA,MTRA,NTRA,A,IA,B,IAMAX,IALIM,
     &             UC,UCM,C,Q,
     &             NSX,NSY,KS,NCX,NCY,KC,NA,DISP)
        PARAMETER  (NSXM=28, NSYM=9, KSMAX=40)
        REAL  UC(-NCX:NCX,-NCY:NCY,KC), UCM(KC)
        REAL  A(-NA:NA,-NA:NA,*), B(KS), C(-NA:NA,-NA:NA)
        INTEGER  IA(KC,KS),DISP,LTRAIN
 
        IF (NSX .GT. NSXM)  STOP 'Too small buf. USI in sub. ORG(NSX)'
        IF (NSY .GT. NSYM)  STOP 'Too small buf. USI in sub. ORG(NSY)'
        IF (KS .GT. KSMAX)  STOP 'Too small buf. MTR, NTR in sub. ORG'
 
        CALL DELTA(A, IA, B, C, UC, UCM, KTRA, MTRA,
     &                   NTRA, IAMAX, IALIM, Q, NCX, NCY, KC, KS, NA)
 
C       --- DISPLAY coeff. A ---
        IF ((DISP .EQ. 1).OR.(DISP .EQ. 3)) THEN
          DO 2005 K1=1,KLAST
              WRITE(*,*) 'KC(',KC,') ---> KS(',K1,')'
              CALL PRINT(A(-NA,-NA,IA(1,K1)),NA,NA,KC,10,LTRAIN,6)
 2005     CONTINUE
        END IF
 
C       --- DISPLAY coeff. B ---
        IF ((DISP .EQ. 2).OR.(DISP .EQ. 3)) THEN
          DO 2006 K1=1,KLAST
            WRITE(*,*) 'B(',K1,')=',B(K1)
 2006     CONTINUE
        END IF
 
        RETURN
        END
 
 
 
 
        SUBROUTINE USINI(USI,UC,UCM,AINI,NSX,NSY,NCX,NCY,KC,NAINI)
 
        REAL  USI(-NSX:NSX,-NSY:NSY)
        REAL  UC(-NCX:NCX,-NCY:NCY,KC), UCM(KC)
        REAL  AINI(-NAINI:NAINI,-NAINI:NAINI)
 
        DO 2001 N=-NSY,NSY
          DO 2000 M=-NSX,NSX
            USI(M,N)=0.0
 2000     CONTINUE
 2001   CONTINUE
 
        DO 2006 KA=1,KC
          IF (UCM(KA) .GT. 0.0)  THEN
            DO 2005 N=-NCY,NCY
              NN1=MAX0(N-NAINI,-NSY)
              NN2=MIN0(N+NAINI, NSY)
              DO 2004 M=-NCX,NCX
                UU=UC(M,N,KA)
                IF (UU .GT. 0.0)  THEN
                  MM1=MAX0(M-NAINI,-NSX)
                  MM2=MIN0(M+NAINI, NSX)
 
                  DO 2003 NN=NN1,NN2
                    DO 2002 MM=MM1,MM2
                      USI(MM,NN)=USI(MM,NN) + AINI(M-MM,N-NN)*UU
 2002               CONTINUE
 2003             CONTINUE
 
                END IF
 2004         CONTINUE
 2005       CONTINUE
          END IF
 2006   CONTINUE
 
        RETURN
        END
 
 
 
 
 
 
        SUBROUTINE LAT(USI,USIM,US,E, NSX, NSY,NE)
C       ***  US and USI can be the same  ***
        PARAMETER  (NSXM=28, NSYM=9)
        REAL  USI(-NSX:NSX,-NSY:NSY), USIM
CC                     ! Input to be inhibited (also Response)
        REAL  US(-NSX:NSX,-NSY:NSY)
C                                  ! Inhibiting stimulus
        REAL  E(-NE:NE,-NE:NE)
C                                  ! Coefficients for inhibition
 
        REAL  W(-NSXM:NSXM,-NSYM:NSYM)
 
        USIM=USIM
        IF (NSX .GT. NSXM)  STOP 'Too small buff. W in sub. LAT(NSX)'
        IF (NSY .GT. NSYM)  STOP 'Too small buff. W in sub. LAT(NSY)'
        DO 2001 N=-NSY,NSY
          DO 2000 M=-NSX,NSX
            W(M,N)=US(M,N)
 2000     CONTINUE
 2001   CONTINUE
 
        DO 2005 N=-NSY,NSY
          NN1=MAX0(N-NE,-NSY)
          NN2=MIN0(N+NE,NSY)
          DO 2004 M=-NSX,NSX
            UU=W(M,N)
            IF (UU .GT. 0.0)  THEN
              MM1=MAX0(M-NE,-NSX)
              MM2=MIN0(M+NE,NSX)
 
              DO 2003 NN=NN1,NN2
                DO 2002 MM=MM1,MM2
                  USI(MM,NN)=USI(MM,NN) - E(M-MM,N-NN)*UU
 2002           CONTINUE
 2003         CONTINUE
 
            END IF
 2004     CONTINUE
 2005   CONTINUE
        DO 2007 N=-NSY,NSY
          DO 2006 M=-NSX,NSX
            IF (USI(M,N) .LT. 0.0)  USI(M,N)=0.0
 2006     CONTINUE
 2007   CONTINUE
 
        RETURN
        END
 
 
 
 
 
 
        SUBROUTINE REP(MTR,NTR,US, NSX, NSY,KS)
        PARAMETER (NSXM=28, NSYM=9)
C                                                !!!
        REAL     US(-NSX:NSX,-NSY:NSY,KS)
        INTEGER  MTR(KS), NTR(KS)
 
        REAL     UMAX(-NSXM:NSXM,-NSYM:NSYM)
        INTEGER  KR(-NSXM:NSXM,-NSYM:NSYM)
 
        INTEGER  NEIB/1/
 
        IF (NSX .GT. NSXM)
     &    STOP 'Too small buffer for UMAX and KR in sub. REP(NSX)'
        IF (NSY .GT. NSYM)
     &    STOP 'Too small buffer for UMAX and KR in sub. REP(NSY)'
 
        DO 2002 N=-NSY,NSY
          DO 2001 M=-NSX,NSX
            UMAX(M,N)=0.0
            KR(M,N)=0
            DO 2000 K=1,KS
              IF (US(M,N,K) .GT. UMAX(M,N))  THEN
                UMAX(M,N)=US(M,N,K)
                KR(M,N)=K
              END IF
 2000       CONTINUE
 2001     CONTINUE
 2002   CONTINUE
 
 
        DO 2005 N=-NSY,NSY
          NN1=MAX0(N-NEIB,-NSY)
          NN2=MIN0(N+NEIB,NSY)
          DO 10 M=-NSX,NSX
            UM=UMAX(M,N)
            IF (UM .GT. 0.0)  THEN
              MM1=MAX0(M-NEIB,-NSX)
              MM2=MIN0(M+NEIB, NSX)
 
              DO 2004 NN=NN1,NN2
                DO 2003 MM=MM1,MM2
                  IF (UMAX(MM,NN) .GT. UM)  THEN
                    KR(M,N)=0
                    GO TO 10
                  ELSE IF (UMAX(MM,NN) .GT. UM)  THEN
                  ELSE IF (UMAX(MM,NN) .LT. UM)  THEN
                  ELSE
                    UMAX(MM,NN) = UM * 0.999
                  CONTINUE
                  END IF
 2003           CONTINUE
 2004         CONTINUE
 
            END IF
 10       CONTINUE
 2005   CONTINUE
 
        DO 2006 K=1,KS
          MTR(K)=99
          NTR(K)=99
 2006   CONTINUE
 
        DO 2007 N=-NSY,NSY
          DO 100 M=-NSX,NSX
            KK=KR(M,N)
            IF (KK.GT.0)  THEN
              IF (MTR(KK) .EQ. 99)  THEN
                MTR(KK)=M
                NTR(KK)=N
              ELSE IF (UMAX(MTR(KK),NTR(KK)) .LT. UMAX(M,N))  THEN
                MTR(KK)=M
                NTR(KK)=N
              END IF
            END IF
 100      CONTINUE
 2007   CONTINUE
        RETURN
        END
 
 
 
 
 
 
        SUBROUTINE SHIFT(P,MM,NN,IT,LTRAIN)
        PARAMETER  (MMM=28,NNM=9)
        REAL  P(-MM:MM,-NN:NN)
        REAL  BUF(-MMM:MMM,-NNM:NNM)
 
        INTEGER
     &    MST(0:15)/0, 1, 0, 1,-1, 2,-1, 2, 0, 1,-1, 2, 0, 1,-1, 2/,
     &    NST(0:15)/0, 0, 1, 1, 0, 0, 1, 1,-1,-1,-1,-1, 2, 2, 2, 2/
 
        IF (LTRAIN .EQ. 2)  THEN
          MODL=4
        ELSE IF (LTRAIN .EQ. 3)  THEN
          MODL=16
        ELSE
          RETURN
        END IF
 
        IF (NN .GT. NNM)
     &      STOP 'Too small buffer BUF in sub. SHIFT(NN)'
        IF (MM .GT. MMM)
     &      STOP 'Too small buffer BUF in sub. SHIFT(MM)'
 
        ISH=MOD(IT, MODL)
        MSH=MST(ISH)
        NSH=NST(ISH)
 
        DO 2001 N=-NN,NN
          DO 2000 M=-MM,MM
            BUF(M,N)=0.0
 2000     CONTINUE
 2001   CONTINUE
 
        NN1=MAX(-NN-NSH,-NN)
        NN2=MIN(NN-NSH,NN)
        DO 2003 N=NN1,NN2
          MM1=MAX(-MM-MSH,-MM)
          MM2=MIN(MM-MSH,MM)
          DO 2002 M=MM1,MM2
            BUF(M+MSH,N+NSH)=P(M,N)
 2002     CONTINUE
 2003   CONTINUE
 
        DO 2005 N=-NN,NN
          DO 2004 M=-MM,MM
            P(M,N)=BUF(M,N)
 2004     CONTINUE
 2005   CONTINUE
 
        RETURN
        END
 
 
 
 
 
 
        SUBROUTINE REPINI(MTRK,NTRK,USI, NSX, NSY, *)
C       ***  RETURN 1:  No representative is selected  ***
        REAL  USI(-NSX:NSX,-NSY:NSY)
 
        UM=0.0
        NTRK=99
        MTRK=99
        DO 2001 N=-NSY,NSY
          DO 2000 M=-NSX,NSX
            IF (USI(M,N) .GT. UM)  THEN
              UM=USI(M,N)
              NTRK=N
              MTRK=M
            END IF
 2000     CONTINUE
 2001   CONTINUE
 
        IF (MTRK .NE. 99)  THEN
          RETURN
        ELSE
          RETURN 1
        END IF
 
        END
 
 
 
 
 
 
        SUBROUTINE DELTA(A,IA,B,C,UC,UCM,KTR,MTR,NTR,IAMAX,IALIM,Q,
     &                   NCX,NCY,KC,KS,NA)
        REAL  UC(-NCX:NCX,-NCY:NCY,KC), UCM(KC)
        REAL  A(-NA:NA,-NA:NA,*), B(KS), C(-NA:NA,-NA:NA)
        INTEGER  IA(KC,KS)
 
        NN1=MAX(NTR-NA, -NCY)
        NN2=MIN(NTR+NA,  NCY)
        MM1=MAX(MTR-NA, -NCX)
        MM2=MIN(MTR+NA,  NCX)
 
        VV=0.0
        DO 2006 K=1,KC
          IF (UCM(K) .GT. 0.0)  THEN
 
            DO 2001 N=NN1,NN2
              DO 2000 M=MM1,MM2
                IF (UC(M,N,K) .GT. 0.0)  GO TO 10
C                                                  ! Exit from do loop
 2000         CONTINUE
 2001       CONTINUE
            GO TO 100
C                       ! Skip the rest of do loop of K
 10         CONTINUE
 
            IAA=IA(K,KTR)
 
            IF (IAA .EQ. 0)  THEN
              IAMAX=IAMAX+1
              IF (IAMAX .GT. IALIM)  THEN
                WRITE (*,1002)  IALIM, KTR
 1002            FORMAT ('TOO SMALL DIMENSION FOR  A  DURING ',
     &                  'TRAINING',5X,'IAMAX > IALIM =',I5,5X,
     &                  'AT  KTR =',I3)
                STOP
              END IF
              IA(K,KTR)=IAMAX
              IAA=IAMAX
              DO 2003 N=-NA,NA
                DO 2002 M=-NA,NA
                  A(M,N,IAA)=0.0
 2002           CONTINUE
 2003         CONTINUE
            END IF
 
            DO 2005 N=NN1,NN2
              DO 2004 M=MM1,MM2
                UU=UC(M,N,K)
                IF (UU .GT. 0.0)  THEN
                  CUU = UU * C(M-MTR,N-NTR)
                  A(M-MTR,N-NTR,IAA) = A(M-MTR,N-NTR,IAA) + Q*CUU
                  VV = VV + CUU*UU
                END IF
 2004         CONTINUE
 2005       CONTINUE
 
 100        CONTINUE
          END IF
 2006   CONTINUE
        B(KTR) = B(KTR) + Q*SQRT(VV)
 
        RETURN
        END
 
 
 
 
 
 
 
        SUBROUTINE NORMALIZ(A,IA,B, KC,KS,NA)
        REAL     A(-NA:NA,-NA:NA,*), B(KS)
        INTEGER  IA(KC,KS)
 
        DO 2006 K=1,KS
          AMAX=0.0
          DO 2002 KA=1,KC
            IAA=IA(KA,K)
            IF (IAA .GT. 0)  THEN
              DO 2001 N=-NA,NA
                DO 2000 M=-NA,NA
                  IF (AMAX .LT. A(M,N,IAA))  AMAX=A(M,N,IAA)
 2000           CONTINUE
 2001         CONTINUE
            END IF
 2002     CONTINUE
 
          IF (AMAX .GT. 0.0)  THEN
            DO 2005 KA=1,KC
              IAA=IA(KA,K)
              IF (IAA .GT. 0)  THEN
                DO 2004 N=-NA,NA
                  DO 2003 M=-NA,NA
                    A(M,N,IAA) = A(M,N,IAA) / AMAX
 2003             CONTINUE
 2004           CONTINUE
              END IF
 2005       CONTINUE
            B(K) = B(K) / AMAX
          END IF
 
 2006   CONTINUE
 
        RETURN
        END
